# opentl::modalities::OpticalFlow Class Reference

Inherits opentl::modalities::Modality.

List of all members.

## Public Types
## Public Member Functions
virtual modalities::Modality * | clone () const
| Creates an additional copy of this class instance.
int | getFeatureCount ()
| return number of features detected
opentl::core::cvdata::LucasKanadeFeatures * | getLucasKanadeFeatures ()
float * | getLucasKanadeFeaturesError ()
char * | getLucasKanadeFeaturesStatus ()
virtual void | init ()
| Initialization function.
virtual int | matchFeatLevel (const TargetPtrVector &targets, T_MEAS_FEATPtrVector &outputMeas, std::size_t partitionIdx)
| Match model.
virtual int | matchObjLevel (const TargetPtrVector &targets, T_MEAS_OBJPtrVector &outputMeas, std::size_t partitionIdx)
| Match model.
| OpticalFlow (const OpticalFlow &c)
| Copy Constructor (deep copy).
| OpticalFlow (opentl::modelprojection::WarpBack *warpBack, int camIdx, opentl::modelprojection::GLRenderer *glRenderer)
| Constructor.
virtual int | preProcess (const opentl::core::cvdata::Image &image, const std::vector< std::vector< int > > &preProcessROIs)
| Converts a given Image into the specified color space To specify the destination color space, please use the param construct.
virtual int | sampleModelFeatures (const TargetPtrVector &targets)
| Sample color histogram from shape and appearance model, at given pose.
void | setInitialImage (const opentl::core::cvdata::Image &image)
| Sets the intial image.
virtual int | updateModelFeatures (const TargetPtrVector &targets)
| Update on-line color histogram from pre-processed image, at given pose.
virtual | ~OpticalFlow ()
| Destructor.
## Static Public Attributes
static std::vector < math::Matrix * > | bodyPointMat
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | eigImage
static std::vector < math::Vector * > | linkIdxOK
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | mPreProcessImage
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | mPreviousImage
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | pyrA
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | pyrB
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | renderImage
static std::vector < math::Matrix * > | screenPointMat
static std::vector < boost::shared_ptr < opentl::core::cvdata::Image > > | tempImage

## Member Enumeration Documentation

enum opentl::modalities::OpticalFlow::OfflineParameters

Parameters for visual processing in this class.

Enumerator:

  MAX_CORNERS | Color channels of pre-processed image (default: HSV).
  qualityLevel |
  minDistance |
  blockSize |
  useHarris |
  k |
  winSize |
  level |
  OFFLINE_COUNT |

Reimplemented from opentl::modalities::Modality.

## Constructor & Destructor Documentation

opentl::modalities::OpticalFlow::OpticalFlow | ( | opentl::modelprojection::WarpBack * | warpBack,
|  | int | camIdx,
|  | opentl::modelprojection::GLRenderer * | glRenderer |
| ) |  |  |

Constructor.

Parameters:

  | warp | Warp instance
  | camIdx | Camera index
  | Pointer | to the GLScene instance

opentl::modalities::OpticalFlow::OpticalFlow | ( | const OpticalFlow & | c | ) |

Copy Constructor (deep copy).

virtual opentl::modalities::OpticalFlow::~OpticalFlow | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual modalities::Modality* opentl::modalities::OpticalFlow::clone | ( |  | ) | const`[virtual]`

Creates an additional copy of this class instance.

Implements opentl::modalities::Modality.

int opentl::modalities::OpticalFlow::getFeatureCount | ( |  | ) | `[inline]`

return number of features detected

opentl::core::cvdata::LucasKanadeFeatures* opentl::modalities::OpticalFlow::getLucasKanadeFeatures | ( |  | ) | `[inline]`

Returns a pointer to the LucasKanade Feature Set.

float* opentl::modalities::OpticalFlow::getLucasKanadeFeaturesError | ( |  | ) | `[inline]`

Returns a pointer to the Status LucasKanade Feature Error.

char* opentl::modalities::OpticalFlow::getLucasKanadeFeaturesStatus | ( |  | ) | `[inline]`

Returns a pointer to the Status LucasKanade Feature Set (1: If Found, 0: If Not Found).

virtual void opentl::modalities::OpticalFlow::init | ( |  | ) | `[virtual]`

Initialization function.

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::OpticalFlow::matchFeatLevel | ( | const TargetPtrVector & | targets,
|  | T_MEAS_FEATPtrVector & | outputMeas,
|  | std::size_t | partitionIdx |
| ) |  |  | `[virtual]`

Match model.

Parameters:

  | targets | Vector of targets
  | outputMeas |

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::OpticalFlow::matchObjLevel | ( | const TargetPtrVector & | targets,
|  | T_MEAS_OBJPtrVector & | outputMeas,
|  | std::size_t | partitionIdx |
| ) |  |  | `[virtual]`

Match model.

Parameters:

  | targets | Vector of targets
  | outputMeas | State-space measurement and residuals

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::OpticalFlow::preProcess | ( | const opentl::core::cvdata::Image & | image,
|  | const std::vector< std::vector< int > > & | preProcessROIs |
| ) |  |  | `[virtual]`

Converts a given Image into the specified color space To specify the destination color space, please use the param construct.

Parameters:

  | image | Input sensor data (e.g. camera image in RGB)
  | preProcessROIs | Regions of interest (x0,y0,width,height), per target

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::OpticalFlow::sampleModelFeatures | ( | const TargetPtrVector & | targets | ) | `[virtual]`

Sample color histogram from shape and appearance model, at given pose.

Parameters:

  | targets | Vector of targets

Reimplemented from opentl::modalities::Modality.

void opentl::modalities::OpticalFlow::setInitialImage | ( | const opentl::core::cvdata::Image & | image | ) |

Sets the intial image.

Parameters:

  | image | Input

virtual int opentl::modalities::OpticalFlow::updateModelFeatures | ( | const TargetPtrVector & | targets | ) | `[virtual]`

Update on-line color histogram from pre-processed image, at given pose.

Parameters:

  | targets | Vector of targets

Reimplemented from opentl::modalities::Modality.

## Member Data Documentation

std::vector<math::Matrix *> opentl::modalities::OpticalFlow::bodyPointMat`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::eigImage`[static]`

std::vector<math::Vector *> opentl::modalities::OpticalFlow::linkIdxOK`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::mPreProcessImage`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::mPreviousImage`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::pyrA`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::pyrB`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::renderImage`[static]`

std::vector<math::Matrix *> opentl::modalities::OpticalFlow::screenPointMat`[static]`

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::modalities::OpticalFlow::tempImage`[static]`